{{*******************************
*  PS/2 Keyboard Driver v2.0  *
*  (C) 2004 Parallax, Inc.    *
*  Modified by Michael Green  *
*   to support Hydra as well  *
*******************************

Object "comboKeyboard_DOL_H" Interface:
}}
PUB  init(dolAddr, sdAddr, heapAddr, this_)
PUB  name
PUB  incRefCount
PUB  decRefCount
PUB  start
PUB  stop
PUB  getRefCount
PUB  startOld(pingroup) : okay
PUB  startx(pingroup, locks, auto) : okay
PUB  stopOld
PUB  present : truefalse
PUB  peekkey : keycode
PUB  key : keycode
PUB  getkey : keycode
PUB  newkey : keycode
PUB  gotkey : truefalse
PUB  clearkeys
PUB  keystate(k) : state
{{
Program:     434 Longs
Variable:     22 Longs

___________________________________________
PUB  init(dolAddr, sdAddr, heapAddr, this_)


_________
PUB  name


________________
PUB  incRefCount


________________
PUB  decRefCount


__________
PUB  start


_________
PUB  stop


________________
PUB  getRefCount


______________________________
PUB  startOld(pingroup) : okay

 Start keyboard driver - starts a cog
 returns false if no cog available

   pingroup = 1st pin number for 2-pin group for PS/2 I/O
              (1st - data signal, 2nd - clock signal)
              Even number selects Demo Board I/O convention

     use 100-ohm resistors between pins and jack
     use 10K-ohm resistors to pull jack-side signals to VDD
     connect jack-power to 5V, jack-gnd to VSS

   pingroup = 1st pin number for 4-pin group for PS/2 I/O
              Odd number selects Hydra I/O convention

   1st pin drives NPN base for PS/2 'data' signal pull-down
   2nd pin reads PS/2 'data' signal
   3rd pin drives NPN base for PS/2 'clock' signal pull-down
   4th pin reads PS/2 'clock' signal

   use 2.2K-ohm resistors between 1st/3rd pins and NPN bases
   use 22K-ohm resistors between 2nd/4th pins and PS/2-side signals
   use 2.2K-ohm resistors to pull PS/2-side signals to 5V
   connect PS/2 power to 5V, PS/2 gnd to vss

 all lock-keys will be enabled, NumLock will be initially 'on',
 and auto-repeat will be set to 15cps with a delay of .5s

_________________________________________
PUB  startx(pingroup, locks, auto) : okay

 Like start, but allows you to specify lock settings and auto-repeat

   locks = lock setup
           bit 6 disallows shift-alphas (case set soley by CapsLock)
           bits 5..3 disallow toggle of NumLock/CapsLock/ScrollLock state
           bits 2..0 specify initial state of NumLock/CapsLock/ScrollLock
           (eg. %0_001_100 = disallow ScrollLock, NumLock initially 'on')

   auto  = auto-repeat setup
           bits 6..5 specify delay (0=.25s, 1=.5s, 2=.75s, 3=1s)
           bits 4..0 specify repeat rate (0=30cps..31=2cps)
           (eg %01_00000 = .5s delay, 30cps repeat)

____________
PUB  stopOld

 Stop keyboard driver - frees a cog

________________________
PUB  present : truefalse

 Check if keyboard present - valid ~2s after start
 returns t|f

______________________
PUB  peekkey : keycode

 Returns a 0 if the buffer is empty
 returns next key if buffer not empty
 but doesn't remove the key from buffer

__________________
PUB  key : keycode

 Get key (never waits)
 returns key (0 if buffer empty)

_____________________
PUB  getkey : keycode

 Get next key (may wait for keypress)
 returns key

_____________________
PUB  newkey : keycode

 Clear buffer and get new key (always waits for keypress)
 returns key

_______________________
PUB  gotkey : truefalse

 Check if any key in buffer
 returns t|f

______________
PUB  clearkeys

 Clear key buffer

________________________
PUB  keystate(k) : state

 Get the state of a particular key
 returns t|f


      _________
      Key Codes

      00..DF  = keypress and keystate
      E0..FF  = keystate only


      09      Tab
      0D      Enter
      20      Space
      21      !
      22      "
      23      #
      24      $
      25      %
      26      &
      27      '
      28      (
      29      )
      2A      *
      2B      +
      2C      ,
      2D      -
      2E      .
      2F      /
      30      0..9
      3A      :
      3B      ;
      3C      <
      3D      =
      3E      >
      3F      ?
      40      @       
      41..5A  A..Z
      5B      [
      5C      \
      5D      ]
      5E      ^
      5F      _
      60      `
      61..7A  a..z
      7B      {
      7C      |
      7D      }
      7E      ~

      80-BF   (future international character support)

      C0      Left Arrow
      C1      Right Arrow
      C2      Up Arrow
      C3      Down Arrow
      C4      Home
      C5      End
      C6      Page Up
      C7      Page Down
      C8      Backspace
      C9      Delete
      CA      Insert
      CB      Esc
      CC      Apps
      CD      Power
      CE      Sleep
      CF      Wakeup

      D0..DB  F1..F12
      DC      Print Screen
      DD      Scroll Lock
      DE      Caps Lock
      DF      Num Lock

      E0..E9  Keypad 0..9
      EA      Keypad .
      EB      Keypad Enter
      EC      Keypad +
      ED      Keypad -
      EE      Keypad *
      EF      Keypad /

      F0      Left Shift
      F1      Right Shift
      F2      Left Ctrl
      F3      Right Ctrl
      F4      Left Alt
      F5      Right Alt
      F6      Left Win
      F7      Right Win

      FD      Scroll Lock State
      FE      Caps Lock State
      FF      Num Lock State

      +100    if Shift
      +200    if Ctrl
      +400    if Alt
      +800    if Win

      eg. Ctrl-Alt-Delete = $6C9


 Note: Driver will buffer up to 15 keystrokes, then ignore overflow.}}