'   fsrw.spin 1.5  7 April 2007   Radical Eye Software  
'
'   This object provides FAT16 file read/write access on a block device.
'   Only one file open at a time.  Open modes are 'r' (read), 'a' (append),
'   'w' (write), and 'd' (delete).  Only the root directory is supported.
'   No long filenames are supported.  We also support traversing the
'   root directory.
'
'   In general, negative return values are errors; positive return
'   values are success.  Other than -1 on popen when the file does not
'   exist, all negative return values will be "aborted" rather than
'   returned.
'
'   Changes:
'       v1.1  28 December 2006  Fixed offset for ctime
'       v1.2  29 December 2006  Made default block driver be fast one
'       v1.3   6 January  2007  Added some docs, and a faster asm
'              9 January  2007  Modified to work with Propeller OS
'             22 January  2007  Added bridge to sdspi routine
'              3 February 2007  More debugging for assembly routines
'              5 February 2007  More work on bootSDCard
'       v1.4  20 February 2007  Updated to FSRW version 1.4 \
'       v1.5   7 April    2007  Fixed problem when directory is larger
'                               than a cluster.

pub start(ioControl)

pub stop

pub bootEEPROM(address)

pub readEEPROM(address, bufAdr, size)

pub writeEEPROM(address, bufAdr, size)

pub checkPresence(address)

pub writeWait(address) | startTime
   
pub initSDCard(DO, Clk, DI, CS)
  
pub stopSDCard
  
pub bootSDCard                    ' Execute up to 32K from current file

pub readSDCard(address, bufAdr, size)
   
pub writeSDCard(address, bufAdr, size)

pub unmount

pub out(c)                        ' Output a single character

pub str(stringptr)                ' Output a zero-terminated string

pub dec(value) | i                ' Output a decimal value
   
pub hex(value, digits)            ' Output a hexadecimal value

pub bin(value, digits)            ' Output a binary value

pub mount(DO, Clk, DI, CS) | startBlk, sectorspercluster, reserved, rootentries, sectors

pub pflush
{{
'   Call flush with the current data buffer location, and the flush
'   metadata flag set.
}}

pub pclose | r
{{
'   Flush and close the currently open file if any.  Also reset the
'   pointers to valid values.  If there is no error, 0 will be returned.
}}

pub popen(s, mode) | i, sentinel, dirptr, freeentry
{{
'   Close any currently open file, and open a new one with the given
'   file name and mode.  Mode can be "r" "w" "a" or "d" (delete).
'   If the file is opened successfully, 0 will be returned.  If the
'   file did not exist, and the mode was not "w" or "a", -1 will be
'   returned.  Otherwise abort will be called with a negative error
'   code.
}}

pub pread(ubuf, count) | r, t
{{
'   Read count bytes into the buffer ubuf.  Returns the number of bytes
'   successfully read, or a negative number if there is an error.
'   The buffer may be as large as you want.
}}

pub pgetc | t
{{
'   Read and return a single character.  If the end of file is
'   reached, -1 will be returned.  If an error occurs, a negative
'   number will be returned.
}}

pub pwrite(ubuf, count) | r, t
{{
'   Write count bytes from the buffer ubuf.  Returns the number of bytes
'   successfully written, or a negative number if there is an error.
'   The buffer may be as large as you want.
}}

pub pputc(c)
{{
'   Write a single character into the file open for write.  Returns
'   0 if successful, or a negative number if some error occurred.
}}

pub opendir | off
{{
'   Close the currently open file, and set up the read buffer for
'   calls to nextfile.
}}

pub nextfile(fbuf) | i, t, at, lns
{{
'   Find the next file in the root directory and extract its
'   (8.3) name into fbuf.  Fbuf must be sized to hold at least
'   13 characters (8 + 1 + 3 + 1).  If there is no next file,
'   -1 will be returned.  If there is, 0 will be returned.
}}
